///////////////////////////////////////////////////////////////////////////////
//
// Meltice 2.x source code.
//
///////////////////////////////////////////////////////////////////////////////
// DI_ARDLL.CPP = DoIt group / for common ARchiver project's DLL functions.
///////////////////////////////////////////////////////////////////////////////
// $Id: DI_ARDLL.CPP,v 1.21 2002/04/24 14:10:56 ardry Exp $ 
///////////////////////////////////////////////////////////////////////////////

#include 	<windows.h>
#include	<shlobj.h>
#include	"di_doit.h"
#include	"u_util.h"

#include	"c_config.h" // for only debug option "NoArDll" and "WriteLog"

//-----------------------------------------------------------------------------
// for Common Archiver Project DLL settings...
#define		SUPPORT_DLL_NUM 	8

HINSTANCE  hInstDll[SUPPORT_DLL_NUM+1];

//dll chk...
static char dllname[SUPPORT_DLL_NUM+1][16] = 
{	"",
	"UNLHA32.DLL",
	"UNZIP32.DLL",
	"ZIP32J.DLL",
	"CAB32.DLL",
	"TAR32.DLL",
	"BGA32.DLL","YZ1.DLL",
	"JACK32.DLL"
};

static char getver_api[SUPPORT_DLL_NUM+1][24] = 
{
	"",
	"UnlhaGetVersion",
	"UnZipGetVersion", 
	"ZipGetVersion",
	"CabGetVersion",
	"TarGetVersion",
	"BgaGetVersion",
	"Yz1GetVersion",
	"JackGetVersion"
};

//archive chk...
static char chkarc_api[SUPPORT_DLL_NUM+1][24] = 
{
	"",
	"UnlhaCheckArchive",
	"UnZipCheckArchive",
	"",						//Dummy (ZIP32J.DLL can not unpack archive file!)
	"CabCheckArchive", 
	"TarCheckArchive", 
	"BgaCheckArchive", 
	"Yz1CheckArchive", 
	"JackCheckArchive"
};

static int chkarc_mode[SUPPORT_DLL_NUM+1] = {0, 4, 0, 0, 1, 0, 0, 0, 0};


//DLL ConfigDialog...
static char cfgdlg_api[SUPPORT_DLL_NUM+1][24] = {
	"",
	"UnlhaConfigDialog",
	"UnZipConfigDialog",
	"ZipConfigDialog",
	"CabConfigDialog",
	"TarConfigDialog",
	"BgaConfigDialog",
	"Yz1ConfigDialog",
	"JackConfigDialog"
};


//open_archive...
static char opnarc_api[SUPPORT_DLL_NUM+1][24] = 
{
	"",
	"UnlhaOpenArchive",
	"UnZipOpenArchive",
	"",						//Dummy (ZIP32J.DLL can not unpack archive file!)
	"CabOpenArchive", 
	"TarOpenArchive", 
	"BgaOpenArchive", 
	"Yz1OpenArchive", 
	"JackOpenArchive"
};

static char clsarc_api[SUPPORT_DLL_NUM+1][24] = 
{
	"",
	"UnlhaCloseArchive",
	"UnZipCloseArchive",
	"",
	"CabCloseArchive", 
	"TarCloseArchive", 
	"BgaCloseArchive", 
	"Yz1CloseArchive", 
	"JackCloseArchive"
};

static char find1st_api[SUPPORT_DLL_NUM+1][24] = 
{
	"",
	"UnlhaFindFirst",
	"UnZipFindFirst",
	"",
	"CabFindFirst", 
	"TarFindFirst", 
	"BgaFindFirst", 
	"Yz1FindFirst", 
	"JackFindFirst"
};

static char findnext_api[SUPPORT_DLL_NUM+1][24] =
{
	"",
	"UnlhaFindNext",
	"UnZipFindNext",
	"",
	"CabFindNext", 
	"TarFindNext", 
	"BgaFindNext", 
	"Yz1FindNext", 
	"JackFindNext"
};

static char getfilename_api[SUPPORT_DLL_NUM+1][24] = 
{
	"",
	"UnlhaGetFileName",
	"UnZipGetFileName",
	"",
	"CabGetFileName",
	"TarGetFileName", 
	"BgaGetFileName", 
	"Yz1GetFileName", 
	""
};

// processing...
static char arcrun_api[SUPPORT_DLL_NUM+1][12] = 
{
	"",
	"Unlha",
	"UnZip",
	"", 
	"Cab", 
	"Tar", 
	"Bga", 
	"Yz1", 
	"JackCombine"
};

static char arcrun_melt_cmd[SUPPORT_DLL_NUM+1][24] = {
	"",
	"x -jf0 -a1 ",
	"-o ", 
	"", 
	"-x -o ", 
	"-x -f ", 
	"x -a -o -r ", 
	"x -y ", 
	""
};

#ifdef	MELTICE
static char dllerr_msg[72][24] = {
	"ERROR_START", //0x8000
	"", //0x8001
	"", //0x8002
	"", //0x8003
	"", //0x8004
	"ERROR_DISK_SPACE",			//0x8005
	"ERROR_READ_ONLY",			//0x8006
	"ERROR_USER_SKIP",			//0x8007
	"ERROR_UNKNOWN_TYPE",		//0x8008
	"ERROR_METHOD",				//0x8009
	"ERROR_PASSWORD_FILE2",		//0x800A
	"ERROR_VERSION",			//0x800B
	"ERROR_FILE_CRC",			//0x800C
	"ERROR_FILE_OPEN",			//0x800D
	"ERROR_MORE_FRESH",			//0x800E
	"ERROR_NOT_EXIST",			//0x800F
	"ERROR_ALREADY_EXIST",		//0x8010
	"ERROR_TOO_MANY_FILES",		//0x8011
	"ERROR_MAKEDIRECTORY",		//0x8012
	"ERROR_CANNOT_WRITE",		//0x8013
	"ERROR_HUFFMAN_CODE",		//0x8014
	"ERROR_COMMENT_HEADER",		//0x8015
	"ERROR_HEADR_CRC",			//0x8016
	"ERROR_HEADER_BROKEN",		//0x8017
	"ERROR_ARC_FILE_OPEN",		//0x8018
	"ERROR_NOT_ARC_FILE",		//0x8019
	"ERROR_CANNOT_READ",		//0x801A
	"ERROR_FILE_STYLE",			//0x801B
	"ERROR_COMMAND_NAME",		//0x801C
	"ERROR_MORE_HEAP_MEMORY",	//0x801D
	"ERROR_ENOUGH_MEMORY",		//0x801E
	"ERROR_ALREADY_RUNNING",	//0x801F
	"ERROR_USER_CANCEL",		//0x8020
	"ERROR_HARC_ISNOT_OPENED",	//0x8021
	"ERROR_NOT_SEARCH_MODE",	//0x8022
	"ERROR_NOT_SUPPORT",		//0x8023
	"ERROR_TIME_STAMP",			//0x8024
	"ERROR_TMP_OPEN",			//0x8025
	"ERROR_LONG_FILE_NAME",		//0x8026
	"ERROR_ARC_READ_ONLY",		//0x8027
	"ERROR_SAME_NAME_FILE",		//0x8028
	"ERROR_NOT_FIND_ARC_FILE",	//0x8029
	"ERROR_RESPONSE_READ",		//0x802A
	"ERROR_NOT_FILENAME",		//0x802B
	"ERROR_TMP_COPY",			//0x802C
	"ERROR_EOF",				//0x802D
	"ERROR_ADD_TO_LARC",		//0x802E
	"ERROR_TMP_BACK_SPACE",		//0x802F
	"ERROR_SHARING",			//0x8030
	"ERROR_NOT_FIND_FILE",		//0x8031
	"ERROR_LOG_FILE",			//0x8032
	"ERROR_NO_DEVICE",			//0x8033
	"ERROR_GET_ATTRIBUTES",		//0x8034
	"ERROR_SET_ATTRIBUTES",		//0x8035
	"ERROR_GET_INFORMATION",	//0x8036
	"ERROR_GET_POINT",			//0x8037
	"ERROR_SET_POINT",			//0x8038
	"ERROR_CONVERT_TIME",		//0x8039
	"ERROR_GET_TIME",			//0x803a
	"ERROR_SET_TIME",			//0x803b
	"ERROR_CLOSE_FILE",			//0x803c
	"ERROR_HEAP_MEMORY",		//0x803d
	"ERROR_HANDLE",				//0x803e
	"ERROR_TIME_STAMP_RANGE",	//0x803f
	"ERROR_MAKE_ARCHIVE",		//0x8040
	"ERROR_NOT_CONFIRM_NAME"	//0x8041
};

void get_dllerr_msg(char *errmsg,int errcode)
{
	if(errcode >= 0x8000 && errcode <= 0x8041)
		lstrcpyn(errmsg,dllerr_msg[errcode-0x8000],64);
	else
		lstrcpyn(errmsg,"UNKNOWN",64);
	
}
#endif

// load Common Archiver's Project DLL
//   return true  -> DLL load success!
//   return false -> DLL load failed.
static bool load_dll(int mode)
{
	if(mode == 0) return false;
	if(get_noardll(0) == true) return false;

	hInstDll[mode] =  LoadLibrary( dllname[mode] );
	if(hInstDll[mode] == NULL) return false;
	return true;
}

// Call archiver DLL config dialog.
//   hDlg     <- HWND hDlg.
//   mode     <- MODE_ZIP, etc...
bool config_dialog(const HWND hDlg, int mode)
{
	typedef bool (WINAPI *PCNFDLGFUNC)(const HWND,LPSTR,const int);
	static char dummybuf[1024];

	if( load_dll(mode) == true){
		PCNFDLGFUNC CfgDlg = (PCNFDLGFUNC)GetProcAddress(hInstDll[mode], cfgdlg_api[mode]);
		if(CfgDlg != NULL) // API function ready...
		{
			return (*CfgDlg)(hDlg,dummybuf, 1);
		}
	}
	return false;
}


// check archive.
//   filename <- input filename for check.
//   mode     <- MODE_ZIP, etc...
//   return true  -> archive file.
//   return false -> etc file.
static bool check_archive(const char * filename, int mode)
{
	typedef bool (WINAPI *PCHKARCFUNC)(LPCSTR,const int);

	if( load_dll(mode) == true){
		PCHKARCFUNC ChkArc = (PCHKARCFUNC)GetProcAddress(hInstDll[mode], chkarc_api[mode]);
		if(ChkArc != NULL) // API function ready...
		{
			return (*ChkArc)(filename,chkarc_mode[mode]);
		}
	}
	return false;
}

// Common Archiver's Project DLL versions.
// Ver.1.34 -> return 134.
int ardll_get_version(int mode)
{
	typedef WORD (WINAPI *PGETVERFUNC)();

	if( load_dll(mode) == true){
		PGETVERFUNC GetVer = (PGETVERFUNC)GetProcAddress(hInstDll[mode], getver_api[mode]);
		if(GetVer != NULL) // API function ready...
		{
			return (int)(*GetVer)();
		}
	}
	return 0;
}


int ardll_check_archive(const char *filename)
{
	//BugFix: TAR32.DLL v0.53 & 0-1byte file check -> Integer Divide by Zero.
	//(0-2byte file isn't archive file!)
	HANDLE chkarcfil = CreateFile( filename, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, NULL, NULL );
	if(GetFileSize(chkarcfil, NULL) <= 2) { CloseHandle(chkarcfil); return 0; }
	CloseHandle(chkarcfil);

	int chkfast; //.??? -> 1st check archive.
	char *str = new char[lstrlen(filename)+1]; lstrcpy(str,filename);
	lstrcpy(str,CharLower(getExpName(getFileName(str))));
	
	if(lstrcmp(str,"lzh")==0||lstrcmp(str,"lzs")==0||lstrcmp(str,"lha")==0)
		chkfast=MODE_LZH;
	else if(lstrcmp(str,"zip")==0||lstrcmp(str,"jar")==0)
		chkfast=MODE_ZIP;
	else if(lstrcmp(str,"cab")==0)
		chkfast=MODE_CAB;
	else if(lstrcmp(str,"tar")==0||lstrcmp(str,"tgz")==0||lstrcmp(str,"tbz")==0
			||lstrcmp(str,"gz")==0||lstrcmp(str,"bz2")==0)
		chkfast=MODE_TAR;
	else if(lstrcmp(str,"bza")==0||lstrcmp(str,"gza")==0)
		chkfast=MODE_BGA;
	else if(lstrcmp(str,"yz1")==0)
		chkfast=MODE_YZ1;
	else
		chkfast=MODE_JAK;
	delete [] str;

	//Check archive by Common archiver project's DLL 
	if( check_archive(filename,chkfast) == true)  return chkfast;
	if( check_archive(filename,MODE_JAK) == true) return MODE_JAK;
	if( check_archive(filename,MODE_YZ1) != false) return MODE_YZ1; 
							//YZ1.DLL return 0 and 2 when archive is yz1 format!
	if( check_archive(filename,MODE_TAR) == true) return MODE_TAR;
	if( check_archive(filename,MODE_BGA) == true) return MODE_BGA;
	if( check_archive(filename,MODE_CAB) == true) return MODE_CAB;
	if( check_archive(filename,MODE_ZIP) == true) return MODE_ZIP;
	if( check_archive(filename,MODE_LZH) == true) return MODE_LZH;
	return 0;
}

// unpack file from archive file.
//  hDlg      <- hWnd.
//  filename  <- archive file.
//  outputdir <- destdir.
//  mode      <- select unpack engine.
int ardll_melt(const HWND hDlg, const char *filename,const char *outputdir,int mode)
{
	int ret;
	typedef BOOL  (WINAPI *PARCRUNFUNC)(const HWND, LPCSTR,LPSTR, const DWORD);
	typedef DWORD (WINAPI *PARCCMBFUNC)(LPCSTR, LPCSTR ); // for JACK32.DLL
	
	if( load_dll(mode) == true){
		if(mode != MODE_JAK)
		{
			PARCRUNFUNC ArcRun = (PARCRUNFUNC)GetProcAddress(hInstDll[mode], arcrun_api[mode]);
			if(ArcRun != NULL) // API function ready...
			{
				char cmdbuf[MAX_PATH * 4];
				wsprintf(cmdbuf,"%s \"%s\" \"%s\"", arcrun_melt_cmd[mode], filename, outputdir);
				if(mode==MODE_TAR)
				{
					wsprintf(cmdbuf,"%s \"%s\" -o \"%s\"", arcrun_melt_cmd[mode], filename, outputdir);
				}
				ret = (*ArcRun)(hDlg,cmdbuf,NULL,0);
#ifdef	MELTICE
				if(get_writelog()==true)
				{
					char *logbuf = new char[MAX_PATH * 5];
					char *errormsg = new char[32]; get_dllerr_msg(errormsg,ret);

					wsprintf(logbuf, "%s : [%s cmd] <%s>",filename, dllname[mode], cmdbuf);
					OutputLog("MELTICE.LOG",logbuf);

					if(ret == 0)
						wsprintf(logbuf, "%s : [OK] Meltice succeeded in processing of this file.",filename);
					else
						wsprintf(logbuf, "%s : [NG] Meltice failed in processing of this file. (0x%04x:%s)",filename,ret,errormsg);
					OutputLog("MELTICE.LOG",logbuf);
					delete [] errormsg;
					delete [] logbuf;
				}
#endif
			return ret;
			}
		}else{	//for JACK32.DLL
			PARCCMBFUNC ArcCmb = (PARCCMBFUNC)GetProcAddress(hInstDll[mode], arcrun_api[mode]);
			if(ArcCmb != NULL) // API function ready...
			{
				ret= (*ArcCmb)(filename,outputdir);

#ifdef	MELTICE
				if(get_writelog()==true)
				{
					char *logbuf = new char[MAX_PATH * 5];
					char *errormsg = new char[32]; get_dllerr_msg(errormsg,ret);
					wsprintf(logbuf, "%s : [%s API] JackCombine(\"%s\",\"%s\");",filename, dllname[mode], filename,outputdir);
					OutputLog("MELTICE.LOG",logbuf);

					if(ret == 0)
					{
						wsprintf(logbuf, "%s : [OK] Meltice succeeded in processing of this file.",filename);
						OutputLog("MELTICE.LOG",logbuf);
					}else{
						wsprintf(logbuf, "%s : [NG] Meltice failed in processing of this file. (0x%x:%s)",filename,ret,errormsg);
						OutputLog("MELTICE.LOG",logbuf);
					}
					delete [] errormsg;
					delete [] logbuf;
				}
#endif
			return ret;
			}
		}
	}
	return false;

}

//for no double make folder function.
// singledir <- if singledir return true then save singledir path.
// return true -> singledir.
// return false -> not single dir.
bool ardll_check_archive_in_singledir
	(const char *filename, char *singledir, int sdlen)
{
	int mode = ardll_check_archive(filename);
	if(mode == MODE_JAK) return true; //Jack must be SingleFile!

	if( mode != MODE_NOT_SUPPORT && load_dll(mode) == true )
	{
		//for OpenArchive API
		typedef HARC (WINAPI *POPNARCFUNC)(const HWND, LPCSTR, const DWORD);
		//for CloseArchive API
		typedef int (WINAPI *PCLSARCFUNC)(HARC);
		//for FindFirst API
		typedef int (WINAPI *PFF_ARCFUNC)(HARC, LPCSTR,INDIVIDUALINFO FAR *);
		//for FindNext API
		typedef int (WINAPI *PFN_ARCFUNC)(HARC,INDIVIDUALINFO FAR *);
		//for GetFileName API
		typedef int (WINAPI *PGFNARCFUNC)(HARC,LPSTR,const int);

		POPNARCFUNC OpnArc = (POPNARCFUNC)GetProcAddress(hInstDll[mode], opnarc_api[mode]);
		PCLSARCFUNC ClsArc = (PCLSARCFUNC)GetProcAddress(hInstDll[mode], clsarc_api[mode]);
		PFF_ARCFUNC FF_Arc = (PFF_ARCFUNC)GetProcAddress(hInstDll[mode], find1st_api[mode]);
		PFN_ARCFUNC FN_Arc = (PFN_ARCFUNC)GetProcAddress(hInstDll[mode], findnext_api[mode]);
		PGFNARCFUNC GfnArc = (PGFNARCFUNC)GetProcAddress(hInstDll[mode], getfilename_api[mode]);

		if(	OpnArc != NULL &&
			ClsArc != NULL &&
			FF_Arc != NULL &&
			FN_Arc != NULL &&
			GfnArc != NULL ) // API function ready...
		{
			char *buff = new char[MAX_PATH*10];   //buffer.
			char *chkbuf = new char[MAX_PATH*10]; //for check.
			bool chk = false; //chk=true  ->Singlefolder false -> not single.
			HARC arc;
			unsigned int iCnt;

			//OpenArchive
			if( mode == MODE_LZH )
			{
				arc = (*OpnArc)(NULL,filename,M_REGARDLESS_INIT_FILE|M_RECOVERY_ON);
			}else{
				arc = (*OpnArc)(NULL,filename,M_REGARDLESS_INIT_FILE);
			}

			INDIVIDUALINFO ivinf;
			(*FF_Arc)(arc,"*",&ivinf); // FindFirst
			(*GfnArc)(arc,buff,MAX_PATH*10); //GetFileName
			iCnt = 1; //FileCount = 1.
			get1stDirName(buff); // hogehoge/foobar/abcde.txt -> hogehoge
			lstrcpyn(chkbuf, buff,MAX_PATH*10); //chkbuf set standard for check
			while( (*FN_Arc)(arc,&ivinf) == 0 ){ // FindNext
				(*GfnArc)(arc,buff,MAX_PATH*10);//GetFileName
				iCnt++;
				get1stDirName(buff);
				if(lstrcmp(buff, chkbuf)==0)
				{
					lstrcpyn(singledir, buff,sdlen);
					chk = true;
				}else{
					chk=false;
					break;
				}
			}
			
			if(iCnt == 1) //for single file in archive file.
			{
				(*FF_Arc)(arc,"*",&ivinf); // FindFirst
				(*GfnArc)(arc,buff,MAX_PATH*10); //GetFileName
				lstrcpyn(chkbuf, buff,MAX_PATH*10); //chkbuf = Original Filename.
				get1stDirName(buff); // SingleFile and SingleDir : hogehoge/abcde.txt -> hogehoge
									 // SingleFile and NotSingleDir : abcde.txt -> abcde.txt
				if(lstrcmp(buff, chkbuf)!=0) // buff <> chkbuf -> singlefile &&singledir.
				{
					lstrcpyn(singledir, buff,sdlen);
					chk = true;
				}
			}

			(*ClsArc)(arc); // Close Archive

			delete [] buff;
			delete [] chkbuf;

			return chk;
		}
	}

	return false;

}


